<?php
/*********************************************************************
*@filename 		system_grpset_schedules_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0        xinw        2009/02/10   modify for ASP4-036
*            2.0        xushanning  2009/04/22   modify for LogvillageChinese
*            2.0        sunhy       2009/05/31   modify for YBR-32
********************************************************************/
class SystemGrpsetSchedulesController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv', 'GenerateFiles');
	var $uses=array('Poll','Group','License', 'Host','Rltshdmod','Somemod','Rlthstgrp','Rltgrpshd','Mailserver','Configure','Module','Grpshd','Grpauth','Hstloghead', 'Validation','Rltuserauth','Authority');
	var $layout='system';

	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle = __('title',$return = true);

		$this->set('netscan_conf', NETSCAN_CONF);
	}

	function index()
	{
		$ck= $this->requestAction("system_all_licenses/check_lic/");
		if($ck===false)
		{
			$this->GenerateFiles->hook_by_ps(0, array('schedule_stop'));
		}

		$lists= $this->requestAction('/system_grpset_schedules/lists',array('return'));
		$this->set('lists',$lists);


	}
	function lists($do=null)
	{
		$this->layout='ajax';
		$err=null;

		$Hosts= $this->Host->findAll(null, null, null,null,null,-1);
		$Polls= $this->Poll->findAll('poll_name is not null', null, null,null,null,-1);

		if (count($Hosts)>0) {
			$have_no_host=false;
		}else {
			$have_no_host=true;
		}
		$this->set('have_no_host', $have_no_host);

		if (count($Polls)>0) {
			$have_no_poll=false;
		}else {
			$have_no_poll=true;
		}
		$this->set('have_no_poll', $have_no_poll);

		$conditions=array('1=1','GROUP BY'=>'Host.host_name');
		$asso = array(
		'Rltgrpshd : rltgrpshds' => array('Rltgrpshd.sch_id =Grpshd.id'),
		'Rlthstgrp : rlthstgrps' => array('Rltgrpshd.group_id = Rlthstgrp.group_id'),
		'Host : hosts' => array('Host.id = Rlthstgrp.host_id'),
		);
		$datapc = $this->Grpshd->findByAsso($conditions, array('count(Host.id) as Host__count','Host.host_name'), null, null, null, $asso);

		$license_endtime=$this->License->findAll(array("1=1"),array("License.end_time"));

		if(!empty($license_endtime[0]['License']['end_time']))
		{
			$data_lic=substr($license_endtime[0]['License']['end_time'],0,4)-date("Y");
			$this->set('year_lic',$data_lic);
			$lic_endY=substr($license_endtime[0]['License']['end_time'],0,10);
			$this->set('lic_endY',substr($license_endtime[0]['License']['end_time'],0,10));
		}

		if($do=='group_null')
		{
			$err[]=__('no_group',true);
		}

		if($do=='d')
		{
			if(isset($this->params['form']['cbid']))
			{


				$condition="";
				foreach($this->params['form']['cbid'] as $key => $value){
					$condition.=$value.",";
				}
				$condition = substr($condition,0,-1);
				$did = $this->Grpshd->findAll(array('Grpshd.id in ('.$condition.')'), 'Grpshd.group_id', null, null, null, 0);


				foreach ($did as $delid)
				{
					$dgroup[]=$delid['Grpshd']['group_id'];
					foreach($this->params['form']['cbid'] as $grpschid){
						$this->Grpshd->del($grpschid);
					}
					$this->GenerateFiles->hook_by_group($delid['Grpshd']['group_id'], array('schedule'));
				}
			}
			else
			{
				$err[]=__('groupSchedules',$return = true)."　".__('E-00200',$return = true);
			}
		}


		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		$condition="";
		foreach($glist as $key => $value){
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		$data = $this->Grpshd->findAll(array('group_id in ('.$condition.')'),null, null,null,null);

		foreach ($data as $dt)
		{
			//================================= SHOW group pc==========
			$grp=$this->Grpauth->getChildrenByParent($dt['Grpshd']['group_id']);
			$condition="";
			foreach($grp as $key => $value){
				$condition.=$key.",";
			}
			$condition = substr($condition,0,-1);

			$out_group=$this->Grpshd->findAll(array('group_id!='.$dt['Grpshd']['group_id']),"distinct(group_id) AS Grpshd__group_id");
			$condition_1="";
			foreach($out_group as $key => $value){
				$condition_1.=$value['Grpshd']['group_id'].",";
			}
			$condition_1 = substr($condition_1,0,-1);

			$not_parents= $this->Group->findAll(array('Group.id!='.$dt['Grpshd']['group_id'],'Group.parent_id!='.$dt['Grpshd']['group_id']));//選択したグループが親ではない子グループ全て
			$condition_2="";
			foreach($not_parents as $key => $value){
				$condition_2.=$value['Group']['id'].",";
			}
			$condition_2 = substr($condition_2,0,-1);
			if(!empty($condition_1) && empty($condition_2))
			{
				$where_notin="Group.id not in (".$condition_1.")";
			}
			elseif(empty($condition_1) && !empty($condition_2))
			{
				$where_notin="Group.id not in (".$condition_2.")";
			}
			elseif(!empty($condition_1) && !empty($condition_2))
			{
				$where_notin="Group.id not in (".$condition_1.",".$condition_2.")";
			}
			else
			{
				$where_notin="1=1";
			}
			$cpc = $this->Rlthstgrp->findAll(array(" group_id in (".$condition.")",$where_notin,'GROUP BY'=>'host_id'),'count(Rlthstgrp.host_id) as Rlthstgrp_count', null,null,null);

			$dt['count']=isset($cpc[0][0]['Rlthstgrp_count']) ? count($cpc) : null;
			$list[]=$dt;
		}
		$this->set('err',$err);
		if(!empty($list))
		{
			$this->set('data',$list);
		}
		//    	debug($list);
		$this->render('lists');
	}

	function detail($id=null,$grp_id=null)
	{
		$this->layout='ajax';

		$license_endtime=$this->License->findAll(array("1=1"),array("License.end_time"));

		if(!empty($license_endtime[0]['License']['end_time']))
		{
			$data_lic=substr($license_endtime[0]['License']['end_time'],0,4)-date("Y");
			$this->set('year_lic',$data_lic);
			$lic_endY=substr($license_endtime[0]['License']['end_time'],0,10);
			$this->set('lic_endY',substr($license_endtime[0]['License']['end_time'],0,10));
		}

		$criteria=array("Grpshd.id=".$id,'group by'=>'Grpshd.group_id,Group.group_name,Grpshd.start_date,Grpshd.end_date,Grpshd.start_time,Grpshd.end_time,Grpshd.weekday,Module.id,Module.module_name,Rltshdmod.inter_time,Rltshdmod.id,Hstloghead.last_time');

		$asso = array(
			'Group : groups : LEFT' => array('Group.id = Grpshd.group_id'),
			'Rltshdmod : rltshdmods : LEFT' => array('Rltshdmod.sch_id = Grpshd.id'),
			'Module : modules:left' => array('Module.id =Rltshdmod.module_id'),
			'Hstloghead : (select A.module_type,max(A.prev_start_time) as last_time,min(secs_between(A.start_time,A.prev_start_time)) as time_between from hstlogheads AS A LEFT JOIN rlthstgrps AS B ON A.host_id=B.host_id INNER JOIN groups AS D on D.id=B.group_id and D.id='.$grp_id.' INNER JOIN (select host_id,module_type,max(start_time) as newest_time from hstlogheads group by host_id,module_type ) AS C ON A.module_type = C.module_type and A.start_time = C.newest_time
	where secs_between(A.start_time,A.prev_start_time) !=0 group by A.module_type ) : LEFT' => array('Hstloghead.module_type = Module.id'),
		);
  		$data = $this->Grpshd->findByAsso($criteria, 
			array('Grpshd.group_id','Group.group_name', 
				'Grpshd.start_date','Grpshd.end_date',
				'Grpshd.netscan_time','Grpshd.start_time',
				'Grpshd.end_time','Grpshd.weekday',
				'Module.id','Module.module_name','Rltshdmod.inter_time','Rltshdmod.id',
				'min(Hstloghead.time_between) as Rltshdmod__timeaft','Hstloghead.last_time as Rltshdmod__lasttime'
				), 
			"Module.id", null, null, $asso);

		$grpshd_data = $this->Grpshd->findById($id);

  //================================= SHOW group pc==========
		$grp=$this->Grpauth->getChildrenByParent($data[0]['Grpshd']['group_id']);
		$condition="";
		foreach($grp as $key => $value){
		$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);

		$out_group=$this->Grpshd->findAll(array('group_id!='.$data[0]['Grpshd']['group_id']),"distinct(group_id) AS Grpshd__group_id");
		$condition_1="";
		foreach($out_group as $key => $value){
		$condition_1.=$value['Grpshd']['group_id'].",";
		}
		$condition_1 = substr($condition_1,0,-1);


		$not_parents= $this->Group->findAll(array('Group.id!='.$data[0]['Grpshd']['group_id'],'Group.parent_id!='.$data[0]['Grpshd']['group_id']));//選択したグループが親ではない子グループ全て
		$condition_2="";
		foreach($not_parents as $key => $value){
			$condition_2.=$value['Group']['id'].",";
		}
		$condition_2 = substr($condition_2,0,-1);
		if(!empty($condition_1) && empty($condition_2))
		{
			$where_notin="Group.id not in (".$condition_1.")";
		}
		elseif(empty($condition_1) && !empty($condition_2))
		{
			$where_notin="Group.id not in (".$condition_2.")";
		}
		elseif(!empty($condition_1) && !empty($condition_2))
		{
			$where_notin="Group.id not in (".$condition_1.",".$condition_2.")";
		}
		else
		{
			$where_notin="1=1";
		}
		
		$conditions=array(" Group.id in (".$condition.")",$where_notin,'GROUP BY'=>'Host.host_name,Host.id,Group.group_name' );
		$asso = array(
			'Rlthstgrp : rlthstgrps' => array('Group.id = Rlthstgrp.group_id'),
			'Host : hosts' => array('Host.id = Rlthstgrp.host_id'),
		);
		$datapc = $this->Group->findByAsso($conditions, array('Host.host_name','Host.id','Group.group_name'), "Group.group_name", null, null, $asso);
		
		$pc_id=null;
		foreach ($datapc as $datapc_id)
		{
			$pc_id.=$datapc_id['Host']['id'].",";
		}
		
		$this->set('count',count($datapc));
		$this->set('datapc',$datapc);
		$this->set('data',$data);
		$this->set('id',$id);
		
		$this->set('grpshd_data',$grpshd_data);
		if (!empty($id)) {
			$asso = array(
				'Rlthstgrp : rlthstgrps' => array('Grpshd.group_id=Rlthstgrp.group_id'),
			);
			$host_num=$this->Grpshd->findByAsso(array('Grpshd.id='.$id),array('Rlthstgrp.host_id'), null, null, null, $asso);
			$this->set('host_num',$host_num);
		}

	}
	
	function add($id=null,$come=null,$id_from_grp=null,$grp_id=null)
	{
		$add=0;
		$err=null;
		$this->layout='ajax';
		//名前表示用
		$glist2 = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		//選択用
		$glist = $this->Group->getChildrenByParent($this->_getUserGroup());
		if(empty($id))
		{
			$asso = array(
				'Group : groups : LEFT' => array('Group.id = Grpshd.group_id'),
			);
			$ha_group = $this->Grpshd->findByAsso(array('1=1'),array('Group.group_name'), null,null,null,$asso);
			foreach ($glist as $key=>$g_list)
			{
				foreach ($ha_group as $ha)
				{
					if($g_list==$ha['Group']['group_name'])
					{
						unset($glist[$key]);
					}
				}
			}
		}

		if(empty($glist))
		{
			$this->lists('group_null');
		}
		$this->set('glist',$glist);
		$this->set('glist2',$glist2);
		$now_group=$this->Group->findAll(array("Group.id=".$this->_getUserGroup()),"Group.group_name");
		$this->set('grpnm',$now_group[0]['Group']['group_name']);
		$data=null;

		$license_endtime=$this->License->findAll(array("1=1"),array("License.end_time"));

		if(!empty($license_endtime[0]['License']['end_time']))
		{
			$data_lic=substr($license_endtime[0]['License']['end_time'],0,4)-date("Y");
			$this->set('year_lic',$data_lic);
			//					echo $data_lic;
			$lic_endY=substr($license_endtime[0]['License']['end_time'],0,10);
			$this->set('lic_endY',substr($license_endtime[0]['License']['end_time'],0,10));
		}

		if(isset($this->data['Group']['group_name']))
		{
			if(empty($id))
			{
				$criteria[]=" Grpshd.group_id=".$this->data['Group']['group_name']." ";
				$asso = array(
					'Rltshdmod : rltshdmods' => array('Rltshdmod.sch_id =Grpshd.id'),
					'Module : modules' => array('Module.id =Rltshdmod.module_id'),
				);
				$data_id = $this->Grpshd->findByAsso($criteria, array('Grpshd.group_id','Grpshd.id' ), null, null, null, null);
				if(!empty($data_id))
				{
					$id=$data_id[0]['Grpshd']['id'];
					$add=1;
				}

			}

			if(!empty($id))
			{
				$criteria[]=" Grpshd.id=".$id." ";
				$asso = array(
					'Rltshdmod : rltshdmods' => array('Rltshdmod.sch_id =Grpshd.id'),
					'Module : modules' => array('Module.id =Rltshdmod.module_id'),
				);
				$data = $this->Grpshd->findByAsso($criteria, array('Grpshd.group_id', 'Grpshd.start_date','Grpshd.end_date','Grpshd.netscan_time',
				'Grpshd.start_time','Grpshd.end_time','Grpshd.weekday','Module.id','Module.module_name','Rltshdmod.inter_time','Rltshdmod.id' ), 'Module.id', null, null, $asso);

				$ck_data=$this->Somemod->findAll();
				$m_data=$this->Module->findAll();
				$lic_mo=null;
				$delmod=array();
				foreach ($ck_data as $ck)
				{
					foreach ($m_data as $da)
					{
						if(md5($da['Module']['module_name']."tail")==$ck['Somemod']['authoritied'])
						{
							$lic_mo.=$da['Module']['id'].",";
						}
					}
				}
				$asso_auth = array(
				'Rltuserauth : rltuserauths' => array('Authority.id=Rltuserauth.authority_id'),
				);
				$user = $this->Session->read('user');
				$hava_auth=$this->Authority->findByAsso(array('user_id='.$user['id']),array('Authority.controller_name'), null, null, null, $asso_auth);
				$m_data1=$this->Module->findAll("module_name='webaccess'");
				foreach ($hava_auth as $ha)
				{
					if (in_array("opu_webs",$ha['Authority']))
					{
						$lic_mo.=$m_data1[0]['Module']['id'].",";
					}
				}

				$lic_mo = substr($lic_mo,0,-1);
				$m_have_id=$this->Rltshdmod->findAll(array("1=1","Rltshdmod.sch_id=".$id),array("distinct(Rltshdmod.module_id) as Rltshdmod__module_id"));
				$condition="";
				foreach($m_have_id as $key => $value){
					$condition.=$value['Rltshdmod']['module_id'].",";
				}
				$condition = substr($condition,0,-1);

				$where[]="id in(".$lic_mo.") ";
				if(!empty($condition))
				{
					$where[]="id not in (".$condition.") ";
					$where[]="id not in (12,13,14) ";
				}
				$m_nothave=$this->Module->findAll($where);
				//    	debug($data);
				foreach ($m_nothave as $key=> $add_mod)
				{
					$data_add[]=$data[0];
					$data_add[$key]['Module']['id']=$add_mod['Module']['id'];
					$data_add[$key]['Module']['module_name']=$add_mod['Module']['module_name'];
					$data_add[$key]['Rltshdmod']['id']=null;


					if($add_mod['Module']['module_name']=='WMI')
					{
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_WMI;
					}
					if($add_mod['Module']['module_name']=='webaccess')
					{
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_WEB;
					}
					if($add_mod['Module']['module_name']=='device')
					{
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_DEV;
					}
					if($add_mod['Module']['module_name']=='fileinfo')
					{
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_FIL;
					}
					if($add_mod['Module']['module_name']=='performance')
					{
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_PER;
					}
					if($add_mod['Module']['module_name']=='event')
					{
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_EVE;
					}
					if($add_mod['Module']['module_name']=='service')
					{
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_SER;
					}
					if($add_mod['Module']['module_name']=='antivirus')
					{
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_ANT;
					}
					if($add_mod['Module']['module_name']=='application')
					{
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_APP;
					}
					if($add_mod['Module']['module_name']=='netscan')
					{
						if(defined("SCHEDULE_NWSCAN"))
							$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_NWSCAN;
						else
							$data_add[$key]['Rltshdmod']['inter_time']=10800;
					}
					if($add_mod['Module']['module_name']=='agent')
					{
						if(defined("SCHEDULE_AGENT"))
							$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_AGENT;
						else
							$data_add[$key]['Rltshdmod']['inter_time']=3600;
					}
					if($add_mod['Module']['module_name']=='filescan')
					{
						if(defined("SCHEDULE_FILESCAN"))
							$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_FILESCAN;
						else
							$data_add[$key]['Rltshdmod']['inter_time']=10800;
					}
					if($add_mod['Module']['module_name']=='timekeeper')
					{
						if(defined("SCHEDULE_TIMEKEEPER"))
							$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_TIMEKEEPER;
						else
							$data_add[$key]['Rltshdmod']['inter_time']=300;
					}

				}
				if(!empty($data_add))
				{
					$data=array_merge($data,$data_add);
				}
			}
			$week=null;
			$this->data['Grpshd']['mon']=='1' ? $week=$week+1 : null;
			$this->data['Grpshd']['tue']=='1' ? $week=$week+2 : null;
			$this->data['Grpshd']['wed']=='1' ? $week=$week+4 : null;
			$this->data['Grpshd']['thu']=='1' ? $week=$week+8 : null;
			$this->data['Grpshd']['fri']=='1' ? $week=$week+16 : null;
			$this->data['Grpshd']['sat']=='1' ? $week=$week+32 : null;
			$this->data['Grpshd']['sun']=='1' ? $week=$week+64 : null;

			$this->data['Grpshd']['none']=='1' ? $week=null : null;
			if(empty($week)&&$this->data['Grpshd']['none']!='1')
			{
				$err[]=__('weeks',$return = true)."　".__('E-00200',$return = true);
			}
			if(isset($this->data['Grpshd']['none']))
			{
				$this->set('wk',$this->data['Grpshd']['none']);
			}


			if(empty($this->data['Grpshd']['start_year'])&&empty($this->data['Grpshd']['start_month']))
			{
				$start_date="2038-01-01";
				$this->set('start_date',$start_date);
			}
			else
			{
				$start_date = $this->data['Grpshd']['start_year']."-".$this->data['Grpshd']['start_month']."-".$this->data['Grpshd']['start_day'];
				$this->set('start_date',$start_date);
			}

			if(empty($this->data['Grpshd']['end_year'])&&empty($this->data['Grpshd']['end_month']))
			{
				$end_date="2038-01-01";
			}
			else
			{
				$end_date = $this->data['Grpshd']['end_year']."-".$this->data['Grpshd']['end_month']."-".$this->data['Grpshd']['end_day'];
				$this->set('end_date',$end_date);
			}


			if(empty($this->data['Grpshd']['start_hour']))
			{
				$start_time="00:00:00";
				$this->set('start_time',$start_time);
			}
			else
			{
				$start_time = $this->data['Grpshd']['start_hour'].":".$this->data['Grpshd']['start_min'].":00";
				$this->set('start_time',$start_time);
			}


			if(empty($this->data['Grpshd']['end_hour']))
			{
				$end_time="23:59:59";
				$this->set('end_time',$end_time);
			}
			else
			{
				if($start_time==$this->data['Grpshd']['end_hour'].":".$this->data['Grpshd']['end_min'].":00")
				{
					$end_time = $this->data['Grpshd']['end_hour'].":".$this->data['Grpshd']['end_min'].":00";
				}
				else
				{
					$end_time = $this->data['Grpshd']['end_hour'].":".$this->data['Grpshd']['end_min'].":59";
				}
				$this->set('end_time',$end_time);
			}
			
			if(empty($this->data['Rltshdmod']['netscan_hour']))
			{
				$netscan_time="00:00:00";
				$this->set('netscan_time',$netscan_time);
			}
			else
			{
				$netscan_time = $this->data['Rltshdmod']['netscan_hour'].":".$this->data['Rltshdmod']['netscan_min'].":00";
				$this->set('netscan_time',$netscan_time);
			}
			
			$license_endtime=$this->License->findAll(array("1=1"),array("License.end_time"));
			if(!empty($license_endtime) && ($end_date>$license_endtime[0]['License']['end_time'])&&$end_date!="2038-01-01")
			{
				$err[]=__('license_endtime',$return = true);
			}
			if(!empty($license_endtime[0]['License']['end_time']))
			{
				$data_lic=substr($license_endtime[0]['License']['end_time'],0,4)-date("Y");
				$this->set('year_lic',$data_lic);
			}

			if($start_date>$end_date)
			{
				$err[]=__('E-01000',$return = true);
			}
			if($start_time>$end_time)
			{
				$err[]=__('E-01200',$return = true);
			}
			if(isset($this->data['Grpshd']['start_year'])&&isset($this->data['Grpshd']['end_year']))
			{
				if(false == checkdate($this->data['Grpshd']['start_month'], $this->data['Grpshd']['start_day'], $this->data['Grpshd']['start_year']) || false == checkdate($this->data['Grpshd']['end_month'], $this->data['Grpshd']['end_day'], $this->data['Grpshd']['end_year']))
				{
					$err[]=__('E-01100',$return = true);
				}
			}
			//====================DATE check=====================================
			$asso = array();
			$modid1 = $this->Module->findByAsso(array("1=1"), array('distinct(Module.module_name) as Module__module_name','Module.id'), 'Module.id', null, null, $asso);
			$errp1=0;
			if(!empty($modid1))
			{
				foreach($modid1 as $mid)
				{
					if(!empty($this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']]))
					{
						if(!$this->Validation->numeric($this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']])&&$errp1==0)
						{
							$errp1=1;
							$err[]=__('inter_time_mes',$return = true)."　".__('E-04000',$return = true);
						}

					}
				}

			}

			$dir_inter_time = null;

			if(empty($id))
			{
				$asso=array();
				$modid = $this->Module->findByAsso(array("1=1"), array('distinct(Module.module_name) as Module__module_name','Module.id'), 'Module.id', null, null, $asso);
				//				debug($modid);
				foreach($modid as $mid)
				{//echo $mid['Module']['module_name']."<br>";
					$intime='';

					if ($mid['Module']['module_name']=='fileinfo') {
						if(isset($this->data['Grpshd']['secend_'.$mid['Module']['id']])&&$this->data['Grpshd']['secend_'.$mid['Module']['id']]=='4')
						{
							$dir_inter_time=$this->data['Grpshd']['inter_time_'.$mid['Module']['id']]*3600*24;
						}
						elseif(isset($this->data['Grpshd']['secend_'.$mid['Module']['id']])&&$this->data['Grpshd']['secend_'.$mid['Module']['id']]=='5')
						{
							$dir_inter_time=$this->data['Grpshd']['inter_time_'.$mid['Module']['id']]*3600*24*30;
						}
					}

					if($mid['Module']['module_name']!='filetransfer'&&$mid['Module']['module_name']!='error'&&$mid['Module']['module_name']!='schedule')
					{
						if(isset($this->data['Rltshdmod']['secend_'.$mid['Module']['id']])&&$this->data['Rltshdmod']['secend_'.$mid['Module']['id']]=='2')
						{
							$intime=$this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']]*60;
						}
						elseif(isset($this->data['Rltshdmod']['secend_'.$mid['Module']['id']])&&$this->data['Rltshdmod']['secend_'.$mid['Module']['id']]=='3')
						{
							$intime=$this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']]*3600;
						}
						else
						{
							if(isset($this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']]))
							{
								$intime=$this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']];
							}
						}

						if($intime<60 && !empty($intime) )
						{
							$err[]=__($mid['Module']['module_name'].'_',true).__('err_settime',$return = true);
						}
					}

				}
			}
			
			if(!empty($id) )
			{
				foreach ($data as $out)
				{//debug($data);
					$intime='';
					if ($out['Module']['module_name']=='fileinfo') {
						if(isset($this->data['Grpshd']['secend_'.$out['Module']['id']])&&$this->data['Grpshd']['secend_'.$out['Module']['id']]=='4')
						{
							$dir_inter_time=$this->data['Grpshd']['inter_time_'.$out['Module']['id']]*3600*24;
						}
						elseif(isset($this->data['Grpshd']['secend_'.$out['Module']['id']])&&$this->data['Grpshd']['secend_'.$out['Module']['id']]=='5')
						{
							$dir_inter_time=$this->data['Grpshd']['inter_time_'.$out['Module']['id']]*3600*24*30;
						}
					}

					if($out['Module']['module_name']!='filetransfer'&&$out['Module']['module_name']!='error'&&$out['Module']['module_name']!='schedule')
					{
						if(isset($this->data['Rltshdmod']['secend_'.$out['Module']['id']])&&$this->data['Rltshdmod']['secend_'.$out['Module']['id']]=='2')
						{
							$intime=$this->data['Rltshdmod']['inter_time_'.$out['Module']['id']]*60;
						}
						elseif(isset($this->data['Rltshdmod']['secend_'.$out['Module']['id']])&&$this->data['Rltshdmod']['secend_'.$out['Module']['id']]=='3')
						{
							$intime=$this->data['Rltshdmod']['inter_time_'.$out['Module']['id']]*3600;
						}
						else
						{
							if(isset($this->data['Rltshdmod']['inter_time_'.$out['Module']['id']]))
							{
								$intime=$this->data['Rltshdmod']['inter_time_'.$out['Module']['id']];
							}
						}

						if($intime<60 && !empty($intime) )
						{
							$err[]=__($out['Module']['module_name'].'_',true).__('err_settime',$return = true);
						}
					}
				}
			}
			if(empty($err))
			{
				$sensor['id']=$id;
				$sensor['group_id']=$this->data['Group']['group_name'];
				$sensor['start_date']="'".$start_date."'";
				$sensor['end_date']="'".$end_date."'";
				$sensor['start_time']=$start_time;
				$sensor['end_time']=$end_time;
				$sensor['weekday']=$week;
				$sensor['netscan_time']=$netscan_time;

				if($this->data['Grpshd']['dev']!='grpshd_dev'){
					$this->data['Grpshd']['dev']='0';
				}else {
					$this->data['Grpshd']['dev']='1';
				}
				$this->data['Grpshd']['hdd']='1';
				if($this->data['Grpshd']['dir']!='grpshd_dir'){
					$this->data['Grpshd']['dir']='0';
				}else {
					$this->data['Grpshd']['dir']='1';
				}
				$sensor['dev_file_flag']=$this->data['Grpshd']['dev'];
				$sensor['hdd_file_flag']=$this->data['Grpshd']['hdd'];
				$sensor['dir_flag']=$this->data['Grpshd']['dir'];
				$sensor['dir_inter_time']=$dir_inter_time;
				if($this->data['Grpshd']['onlogon']!='onlogon'){
					$this->data['Grpshd']['onlogon']='0';
				}else {
					$this->data['Grpshd']['onlogon']='1';
				}
				$sensor['onlogon']=$this->data['Grpshd']['onlogon'];
				
				$this->Grpshd->save($sensor);
				if(!empty($id))
				{
					$lastid=$id;
				}
				else
				{
					$lastid=$this->Grpshd->field('id','1=1','id desc');
				}
				////
				$pd_id=$this->Rltgrpshd->findAll(array('group_id='.$this->data['Group']['group_name']),array('sch_id'));
				if(!empty($pd_id[0]['Rltgrpshd']['sch_id'])&&empty($id))
				{
					$id=$pd_id[0]['Rltgrpshd']['sch_id'];
					$add='1';
				}
				if(!empty($id) && $add!=1)
				{
					foreach ($data as $out)
					{
						if(($out['Module']['id']!= 12)&& $out['Module']['id']!= 13 && $out['Module']['id']!= 14)
						{
							if(isset($this->data['Rltshdmod']['inter_time_'.$out['Module']['id']])&&$this->Validation->blank($this->data['Rltshdmod']['inter_time_'.$out['Module']['id']]))
							{
								$this->data['Rltshdmod']['inter_time_'.$out['Module']['id']]='0';
							}
							$mods['id']=$out['Rltshdmod']['id'];
							//	    			$mods['inter_time']=$out['Rltshdmod']['inter_time_'.$out['Rltshdmod']['id']];
							if(isset($this->data['Rltshdmod']['secend_'.$out['Module']['id']])&&$this->data['Rltshdmod']['secend_'.$out['Module']['id']]=='2')
							{
								$mods['inter_time']=$this->data['Rltshdmod']['inter_time_'.$out['Module']['id']]*60;
							}
							elseif(isset($this->data['Rltshdmod']['secend_'.$out['Module']['id']])&&$this->data['Rltshdmod']['secend_'.$out['Module']['id']]=='3')
							{
								$mods['inter_time']=$this->data['Rltshdmod']['inter_time_'.$out['Module']['id']]*3600;
							}
							else
							{
								if(isset($this->data['Rltshdmod']['inter_time_'.$out['Module']['id']]))
								{
									$mods['inter_time']=$this->data['Rltshdmod']['inter_time_'.$out['Module']['id']];
								}
							}
							if(empty($out['Rltshdmod']['id']) && ($out['Module']['id']!= 12)&& $out['Module']['id']!= 13 && $out['Module']['id']!= 14)
							{
								$mods['sch_id']=$id;
								$mods['module_id']=$out['Module']['id'];

							}
							$this->Rltshdmod->save($mods);
						}
					}

				}
				elseif(empty($id))
				{	//echo "====2====";
					$asso = array(
					);
					$modid = $this->Module->findByAsso(array("1=1"), array('distinct(Module.module_name) as Module__module_name','Module.id'), null, null, null, $asso);
					$errp=0;
					foreach($modid as $mid)
					{

						if(empty($err)){
							//						echo "000000000000";
							if(!empty($this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']]))
							{
								if($this->data['Rltshdmod']['secend_'.$mid['Module']['id']]=='2')
								{
									$mods['inter_time']=$this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']]*60;
								}
								elseif($this->data['Rltshdmod']['secend_'.$mid['Module']['id']]=='3')
								{
									$mods['inter_time']=$this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']]*3600;
								}
								else
								{
									if(isset($this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']]))
									{
										$mods['inter_time']=$this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']];
									}
								}



								$mwhere[]="Rltshdmod.module_id=".$mid['Module']['id'];
								$mwhere[]="Rltshdmod.sch_id=".$lastid;
								$moid=$this->Rltshdmod->find($mwhere,'Rltshdmod.id');
								!empty($moid['Rltshdmod']['id'])? $mdid=$moid['Rltshdmod']['id'] :$mdid=null;
								$mods['id']=$mdid;
								//				    			$mods['inter_time']=$this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']];
								$mods['module_id']=$mid['Module']['id'];
								$mods['sch_id']=$lastid;
								$this->Rltshdmod->save($mods);


							}
							elseif(isset($this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']])&&empty($this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']]))
							{
								$mwhere[]="Rltshdmod.module_id=".$mid['Module']['id'];
								$mwhere[]="Rltshdmod.sch_id=".$lastid;
								$moid=$this->Rltshdmod->find($mwhere,'Rltshdmod.id');
								!empty($moid['Rltshdmod']['id'])? $mdid=$moid['Rltshdmod']['id'] :$mdid=null;
								$mods['id']=$mdid;
								$mods['inter_time']='0';
								$mods['module_id']=$mid['Module']['id'];
								$mods['sch_id']=$lastid;
								$this->Rltshdmod->save($mods);
							}
						}
					}
					$glist = $this->Group->getChildrenByParent($this->data['Group']['group_name']);
					if(empty($err))
					{
						$grpshd['group_id']=$this->data['Group']['group_name'];
						$grpshd['sch_id']=$lastid;
						$grpshd['org_grp_id']=$lastid;
						$this->Rltgrpshd->save($grpshd);
					}
				}
				$this->GenerateFiles->hook_by_group($this->data['Group']['group_name'], array('schedule'));
			}
		}



		$criteria[]="1=1";
		if(!empty($id))
		{
			$criteria=array(" Grpshd.id=".$id,'group by'=>'Grpshd.group_id,Grpshd.start_date,Grpshd.end_date,Grpshd.start_time,Grpshd.end_time,Grpshd.weekday,Module.id,Module.module_name,Rltshdmod.inter_time,Rltshdmod.id,Hstloghead.last_time');
			empty($grp_id)?$grp_id=$id:null;
			$this->set('grp_id',$grp_id);
			$asso = array(
			'Rltshdmod : rltshdmods:left' => array('Rltshdmod.sch_id =Grpshd.id'),
			'Module : modules:left' => array('Module.id =Rltshdmod.module_id'),
			  'Hstloghead : (select A.module_type,max(A.prev_start_time) as last_time,min(secs_between(A.start_time,A.prev_start_time)) as time_between from hstlogheads AS A LEFT JOIN rlthstgrps AS B ON A.host_id=B.host_id INNER JOIN groups AS D on D.id=B.group_id and D.id='.$grp_id.' INNER JOIN (select host_id,module_type,max(start_time) as newest_time from hstlogheads group by host_id,module_type ) AS C ON A.module_type = C.module_type and A.start_time = C.newest_time where secs_between(A.start_time,A.prev_start_time) !=0 group by A.module_type ):left' => array('Hstloghead.module_type = Module.id'),
			);
			$data = $this->Grpshd->findByAsso($criteria, array('Grpshd.group_id','Grpshd.start_date','Grpshd.end_date',
			'Grpshd.netscan_time',
			'Grpshd.start_time','Grpshd.end_time','Grpshd.weekday','Module.id','Module.module_name','Rltshdmod.inter_time','Rltshdmod.id','min(Hstloghead.time_between) as Rltshdmod__timeaft','Hstloghead.last_time as Rltshdmod__lasttime'),null, null, null, $asso);
			
			$grpshd_data = $this->Grpshd->findById($id);
			$ck_data=$this->Somemod->findAll();
			$m_data=$this->Module->findAll();
			$lic_mo=null;
			$delmod=array();
			foreach ($ck_data as $ck)
			{
				foreach ($m_data as $da)
				{
					if(md5($da['Module']['module_name']."tail")==$ck['Somemod']['authoritied'])
					{
						$lic_mo.=$da['Module']['id'].",";
					}
				}
			}
			$asso_auth = array(
			'Rltuserauth : rltuserauths' => array('Authority.id=Rltuserauth.authority_id'),
			);
			$user = $this->Session->read('user');
			$hava_auth=$this->Authority->findByAsso(array('user_id='.$user['id']),array('Authority.controller_name'), null, null, null, $asso_auth);
			$m_data1=$this->Module->findAll("module_name='webaccess'");
			foreach ($hava_auth as $ha)
			{
				if (in_array("opu_webs",$ha['Authority']))
				{
					$lic_mo.=$m_data1[0]['Module']['id'].",";
				}
			}
			
			$lic_mo = substr($lic_mo,0,-1);
			$m_have_id=$this->Rltshdmod->findAll(array("1=1","Rltshdmod.sch_id=".$id),array("distinct(Rltshdmod.module_id) as Rltshdmod__module_id"));
			$condition="";
			foreach($m_have_id as $key => $value){
				$condition.=$value['Rltshdmod']['module_id'].",";
			}
			$condition = substr($condition,0,-1);
			
			$where[]="id in(".$lic_mo.") ";
			if(!empty($condition))
			{
				$where[]="id not in (".$condition.") ";
				$where[]="id not in (12,13,14) ";
			}
			$m_nothave=$this->Module->findAll($where);
			
			foreach ($m_nothave as $key=> $add_mod)
			{
				$data_add[]=$data[0];
				$data_add[$key]['Module']['id']=$add_mod['Module']['id'];
				$data_add[$key]['Module']['module_name']=$add_mod['Module']['module_name'];
				$data_add[$key]['Rltshdmod']['id']=null;
				//    	echo $add_mod['Module']['module_name'];
				//    	debug($data_add);
				if($add_mod['Module']['module_name']=='WMI')
				{
					$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_WMI;
				}
				if($add_mod['Module']['module_name']=='webaccess')
				{
					$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_WEB;
				}
				if($add_mod['Module']['module_name']=='device')
				{
					$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_DEV;
				}
				if($add_mod['Module']['module_name']=='fileinfo')
				{
					$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_FIL;
				}
				if($add_mod['Module']['module_name']=='performance')
				{
					$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_PER;
				}
				if($add_mod['Module']['module_name']=='event')
				{
					$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_EVE;
				}
				if($add_mod['Module']['module_name']=='service')
				{
					$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_SER;
				}
				if($add_mod['Module']['module_name']=='antivirus')
				{
					$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_ANT;
				}
				if($add_mod['Module']['module_name']=='application')
				{
					$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_APP;
				}
				if($add_mod['Module']['module_name']=='agent')
				{
					if(defined("SCHEDULE_AGENT"))
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_AGENT;
					else
						$data_add[$key]['Rltshdmod']['inter_time']=3600;
				}
				if($add_mod['Module']['module_name']=='filescan')
				{
					if(defined("SCHEDULE_FILESCAN"))
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_FILESCAN;
					else
						$data_add[$key]['Rltshdmod']['inter_time']=10800;
				}
				if($add_mod['Module']['module_name']=='timekeeper')
				{
					if(defined("SCHEDULE_TIMEKEEPER"))
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_TIMEKEEPER;
					else
						$data_add[$key]['Rltshdmod']['inter_time']=300;
				}
			
			}
			if(!empty($data_add))
			{
				$data=array_merge($data,$data_add);
			}
			
			if(isset($this->data['Group']['group_name'])&&empty($err))
			{
				$this->lists();
			}
		}
		else
		{

			$asso = array(
			);
			$data = $this->Module->findByAsso(array('1=1'), array('distinct(Module.module_name) as Module__module_name','Module.id'), "Module.id", null, null, $asso);
			foreach ($data as $key=>$dt)
			{
				if($dt['Module']['module_name']=='WMI')
				{
					$data[$key]['Module']['sche']=SCHEDULE_WMI;
				}
				if($dt['Module']['module_name']=='webaccess')
				{
					$data[$key]['Module']['sche']=SCHEDULE_WEB;
				}
				if($dt['Module']['module_name']=='device')
				{
					$data[$key]['Module']['sche']=SCHEDULE_DEV;
				}
				if($dt['Module']['module_name']=='fileinfo')
				{
					$data[$key]['Module']['sche']=SCHEDULE_FIL;
				}
				if($dt['Module']['module_name']=='performance')
				{
					$data[$key]['Module']['sche']=SCHEDULE_PER;
				}
				if($dt['Module']['module_name']=='event')
				{
					$data[$key]['Module']['sche']=SCHEDULE_EVE;
				}
				if($dt['Module']['module_name']=='service')
				{
					$data[$key]['Module']['sche']=SCHEDULE_SER;
				}
				if($dt['Module']['module_name']=='antivirus')
				{
					$data[$key]['Module']['sche']=SCHEDULE_ANT;
				}
				if($dt['Module']['module_name']=='application')
				{
					$data[$key]['Module']['sche']=SCHEDULE_APP;
				}
				if($dt['Module']['module_name']=='netscan')
				{
					if(defined("SCHEDULE_NWSCAN"))
						$data[$key]['Module']['sche']=SCHEDULE_NWSCAN;
					else
						$data[$key]['Module']['sche']=10800;
				}
				if($dt['Module']['module_name']=='agent')
				{
					if(defined("SCHEDULE_AGENT"))
						$data[$key]['Module']['sche']=SCHEDULE_AGENT;
					else
						$data[$key]['Module']['sche']=3600;
				}
				if($dt['Module']['module_name']=='filescan')
				{
					if(defined("SCHEDULE_FILESCAN"))
						$data[$key]['Module']['sche']=SCHEDULE_FILESCAN;
					else
						$data[$key]['Module']['sche']=10800;
				}
				if($dt['Module']['module_name']=='timekeeper')
				{
					if(defined("SCHEDULE_TIMEKEEPER"))
						$data[$key]['Module']['sche']=SCHEDULE_TIMEKEEPER;
					else
						$data[$key]['Module']['sche']=300;
				}
			}

			if(isset($this->data['Group']['group_name'])&&empty($err))
			{
				$this->lists();
			}

		}
		$ckdata=$this->Somemod->findAll();
		$this->set('ckdata',$ckdata);
		$this->set('data',$data);
		$this->set('id',$id);
		$this->set('err',$err);
		$this->set('grpshd_data',$grpshd_data);

		!empty($come)?$this->set('come',$come):null;

		$file_sign = $this->Somemod->findAll();
		$this->set('file_sign',$file_sign);

		$asso_auth = array(
		'Rltuserauth : rltuserauths' => array('Authority.id=Rltuserauth.authority_id'),
		);
		$user = $this->Session->read('user');
		$hava_auth=$this->Authority->findByAsso(array('user_id='.$user['id']),array('Authority.controller_name'), null, null, null, $asso_auth);
		$opu_webs="";
		$oper="";
		for ($i=0;$i<count($hava_auth);$i++)
		{
			if ($hava_auth[$i]['Authority']['controller_name']=='opu_webs') {
				$opu_webs="yes";
				$k=count($ckdata);
				$code=md5("webaccesstail");
				if (!in_array($code,$ckdata)) {
					$ckdata[$k]['Somemod']['authoritied']=$code;
				}
			}
		}

		$this->set('ckdata',$ckdata);

		if (!empty($id_from_grp) && $id_from_grp!="null" ) {
			$this->data['Group']['group_name']=$id_from_grp;
			$this->set('id_from_grp',$id_from_grp);
		}
		
		
		if(!empty($id_from_grp) && $id_from_grp!="null" )
		{
			foreach ($glist as $key=>$g_list)
			{
						if ($key!=$id_from_grp) {
							unset($glist[$key]);
						}		
			}
		}
		$this->set('glist',$glist);

		if (!empty($id)) {
			$asso = array(
				'Rlthstgrp : rlthstgrps' => array('Grpshd.group_id=Rlthstgrp.group_id'),
			);
			$host_num=$this->Grpshd->findByAsso(array('Grpshd.id='.$id),array('Rlthstgrp.host_id'), null, null, null, $asso);
			$this->set('host_num',$host_num);
		}

	}

	function lic()
	{
		$ckdata=$this->Somemod->findAll();
		$data=$this->Module->findAll();
		$lic_mo=null;
		$delmod=array();
		foreach ($ckdata as $ck)
		{
			foreach ($data as $da)
			{
				if(md5($da['Module']['module_name']."tail")==$ck['Somemod']['authoritied'])
				{
					$lic_mo.=$da['Module']['id'].",";
				}
			}
		}
		$lic_mo = substr($lic_mo,0,-1);
		if(!empty($lic_mo))
		{
			$delmod[]="module_id not in(".$lic_mo.") ";
			$delmod[]="module_id not in(12,13,14) ";

		}
		else
		{
			$delmod[]="1=1";
			$delmod[]="module_id not in(12,13,14) ";
		}
		$this->Rltshdmod->deleteAll($delmod);

		$license_endtime=$this->License->findAll(array("1=1"),array("License.end_time"));

		$set_endtime=$this->Grpshd->findAll(array("1=1"),array("Grpshd.id","Grpshd.start_date","Grpshd.end_date"));
		if(!empty($set_endtime))
		{
			foreach ($set_endtime as $endtime)
			{

				$lic_date=array();
				if(($endtime['Grpshd']['end_date'] > $license_endtime[0]['License']['end_time']) && ($endtime['Grpshd']['end_date']!='2038-01-01') )
				{

					if(($endtime['Grpshd']['start_date']>$license_endtime[0]['License']['end_time']))  //無期限
					{
						$lic_date['start_date']="'".$license_endtime[0]['License']['end_time']."'";
						$lic_date['end_date']="'".$license_endtime[0]['License']['end_time']."'";
					}
					else
					{
						$lic_date['end_date']="'".$license_endtime[0]['License']['end_time']."'";
					}
					$lic_date['id']=$endtime['Grpshd']['id'];
					$this->Grpshd->save($lic_date);

				}

			}
		}
		$this->GenerateFiles->hook_by_ps(0, array('schedule'), 1);
	}
}
?>